"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BindGkInfoAndInjectToReqMiddleWare = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var _util = require("./util");

var _Decorators = require("./Decorators");

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var BindGkInfoAndInjectToReqMiddleWare = function BindGkInfoAndInjectToReqMiddleWare(_ref) {
  var GKP_or_GKAPI = _ref.GKP_or_GKAPI,
      expressObj = _ref.expressObj,
      parseServiceEndPoint = _ref.parseServiceEndPoint;
  if (typeof GKP_or_GKAPI !== "function") throw new Error('parseGkInfoAndInjectToReqMiddleWare的GKP_or_GKAPI参数不是有效的函数！');
  if (!expressObj) throw new Error('parseGkInfoAndInjectToReqMiddleWare的expressObj参数未传入！');
  if (expressObj.__parsed) return;
  expressObj.__parsed = true;
  console.log("\nBindGkInfoAndInjectToReqMiddleWare:\u6CE8\u5165[\u68C0\u6D4B\u5F53\u524D\u7528\u6237/\u673A\u6784]\u7684\u4E2D\u95F4\u4EF6\uFF0C\u5C06\u4E24\u8005\u4FE1\u606F\u52A8\u6001\u7ED1\u5B9A\u5230req\u5BF9\u8C61\u4E0A\uFF0C\u63D0\u4F9B\u4EE5\u4E0B\u4FE1\u606F\uFF1A\n    req.__partner //\u5F53\u524D\u673A\u6784\u4FE1\u606F\n    req.__partner_error //\u5F53\u524D\u673A\u6784\u4FE1\u606F\n    req.__gankaoUID     //\u5F53\u524D\u767B\u5F55\u7528\u6237UID\uFF0C\u672A\u767B\u5F55\u65F6\u4E3A0\n    req.__userInfo,     //\u5F53\u524D\u767B\u5F55\u7528\u6237\uFF0C\u672A\u767B\u5F55\u65F6\u4E3Anull\n    /p-**/_current      //\u83B7\u5F97\u5F53\u524D\u4FE1\u606F\u7684\u8DEF\u7531\uFF0C\u8FD4\u56DE\u7ED3\u6784\uFF1A{__partner, __partner_error, __gankaoUID, __userInfo}\n    /api-**/_current      //\u540C\u4E0A\uFF0CAPI\u7528\n    /p-**/_hello        //\u5B58\u6D3B\u63A2\u9488\u68C0\u6D4B\uFF0C\u8FD4\u56DE\u4E00\u4E2A\u6D4B\u8BD5\u7528json\uFF0C\u5982:{ok: 'hello! pass ?test=1 for await 300ms'}\n    /api-**/_hello        //\u540C\u4E0A\uFF0CAPI\u7528\n    ");
  console.log("expressObj.__parsed:", expressObj.__parsed);
  expressObj.use(
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(req, res, next) {
      var env_name, hostname, _ref3, __partner, __partner_error, AuthorizationOrToken, apiUrl_user, query_user, res_user, jsonResult, err, result, _ref6, gankaoUID, gankaoUserInfo;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!((req.path || "").indexOf("/_next/") > -1)) {
                _context2.next = 2;
                break;
              }

              return _context2.abrupt("return", next());

            case 2:
              //这里的process.env.PRODUCTION_TYPE会在babel编译期被替换为实际值
              env_name = process.env.PRODUCTION_TYPE || 'development';

              if (!parseServiceEndPoint) {
                parseServiceEndPoint = "https://api.".concat(env_name === "production" ? "gankao.com" : "gankaotest2.com", "/api-account");
                console.log('配置默认的登录状态查验服务：' + parseServiceEndPoint);
              }

              req.__partner = null;
              req.__partner_error = null;
              req.__gankaoUID = 0;
              req.__userInfo = null;
              req.__userInfo_error = null;
              hostname = req.headers["host"];
              _context2.next = 12;
              return (0, _Decorators.GKCache_remember)(hostname, 30,
              /*#__PURE__*/
              _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee() {
                var apiUrl, query, res2, jsonResult, err, result, _ref5, partner, failMessage;

                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        apiUrl = parseServiceEndPoint + "/gkauth/parsePartner?partnerIdOrEnameOrHostName=".concat(hostname);
                        query = {
                          method: 'GET',
                          rejectUnauthorized: false,
                          headers: {
                            'Accept': 'application/json, text/plain, */*',
                            'Content-Type': 'application/json'
                          },
                          json: true
                        };

                        if (process.env.NODE_ENV === 'development') {
                          console.log("apiUrl:", apiUrl);
                          console.log("query:", query);
                        }

                        _context.next = 5;
                        return (0, _isomorphicFetch["default"])(apiUrl, query);

                      case 5:
                        res2 = _context.sent;
                        _context.next = 8;
                        return res2.json();

                      case 8:
                        jsonResult = _context.sent;

                        if (process.env.NODE_ENV === 'development') {
                          console.log(jsonResult);
                        }

                        err = jsonResult.err, result = jsonResult.result;

                        if (!err) {
                          _context.next = 15;
                          break;
                        }

                        return _context.abrupt("return", {
                          __partner: null,
                          __partner_error: err
                        });

                      case 15:
                        _ref5 = result || {}, partner = _ref5.partner, failMessage = _ref5.failMessage;

                        if (partner) {
                          //注意，需要删除机构密钥值，这个机构密钥后续不能放在partner表里
                          delete partner.encrypt;

                          try {
                            partner.settings = JSON.parse(partner.settings);
                          } catch (e) {
                            partner.settings = {
                              __message: 'parse error in api'
                            };
                          }

                          partner.aimodel = ~~partner.orgType === 2 ? 2 : partner.aimodel; //

                          try {
                            //渠道不存在，则补2个cookie, 这两个cookie是原PHP主站需要的，实际作用需参考PHP源码
                            if (!res.cookie.PARTNER_ID || res.cookie.PARTNER_ID !== partner.ename) {
                              res.cookie("PARTNER_ID", partner.ename, {
                                domain: (0, _util.getCookieDomain2)(req),
                                httpOnly: true,
                                path: '/'
                              });
                            }

                            if (!res.cookie.channel_id || res.cookie.channel_id !== partner.ename) {
                              res.cookie("channel_id", partner.ename, {
                                domain: (0, _util.getCookieDomain2)(req),
                                httpOnly: true,
                                path: '/'
                              });
                            }
                          } catch (e) {
                            console.error(e.stack);
                            console.error(e.message);
                          }
                        }

                        return _context.abrupt("return", {
                          __partner: partner,
                          __partner_error: failMessage
                        });

                      case 18:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              })));

            case 12:
              _ref3 = _context2.sent;
              __partner = _ref3.__partner;
              __partner_error = _ref3.__partner_error;
              req.__partner = __partner;
              req.__partner_error = __partner_error;
              req.__gankaoUID = 0;
              AuthorizationOrToken = req.header('Authorization') || req.header('authorization') || req.query.authorization || req.query.Authorization || req.cookies.gkAuthorization || req.cookies.student || '';
              apiUrl_user = parseServiceEndPoint + "/gkauth/parseUser?AuthorizationOrToken=".concat(AuthorizationOrToken);
              query_user = {
                method: 'GET',
                rejectUnauthorized: false,
                headers: {
                  'Accept': 'application/json, text/plain, */*',
                  'Content-Type': 'application/json'
                },
                json: true
              };

              if (process.env.NODE_ENV === 'development') {
                console.log("apiUrl:", apiUrl_user);
                console.log("query:", query_user);
              }

              _context2.next = 24;
              return (0, _isomorphicFetch["default"])(apiUrl_user, query_user);

            case 24:
              res_user = _context2.sent;
              _context2.next = 27;
              return res_user.json();

            case 27:
              jsonResult = _context2.sent;

              if (process.env.NODE_ENV === 'development') {
                console.log(jsonResult);
              }

              err = jsonResult.err, result = jsonResult.result;

              if (err) {
                req.__userInfo_error = err;
              } else {
                _ref6 = result || {}, gankaoUID = _ref6.gankaoUID, gankaoUserInfo = _ref6.gankaoUserInfo;
                req.__gankaoUID = gankaoUID;
                req.__userInfo = gankaoUserInfo;
              }

              next();

            case 32:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x, _x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }());
  /**
   * 当前访问者的用户与机构信息
   */

  expressObj.use(GKP_or_GKAPI(_templateObject || (_templateObject = _taggedTemplateLiteral(["/_current"]))),
  /*#__PURE__*/
  function () {
    var _ref7 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(req, res, next) {
      var __partner, __partner_error, __gankaoUID, __userInfo, __userInfo_error;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              __partner = req.__partner, __partner_error = req.__partner_error, __gankaoUID = req.__gankaoUID, __userInfo = req.__userInfo, __userInfo_error = req.__userInfo_error;
              res.json({
                __partner: __partner,
                __partner_error: __partner_error,
                __gankaoUID: __gankaoUID,
                __userInfo: __userInfo,
                __userInfo_error: __userInfo_error
              });

            case 2:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x4, _x5, _x6) {
      return _ref7.apply(this, arguments);
    };
  }());
  /**
   * 存活行探针，内有300毫秒的等待，配合压力测试
   */

  expressObj.use(GKP_or_GKAPI(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["/_hello"]))),
  /*#__PURE__*/
  function () {
    var _ref8 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(req, res, next) {
      var _req$query$test, test;

      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _req$query$test = req.query.test, test = _req$query$test === void 0 ? 0 : _req$query$test;

              if (!(~~test === 1)) {
                _context4.next = 4;
                break;
              }

              _context4.next = 4;
              return (0, _util.sleep)(300);

            case 4:
              res.json({
                ok: "hello! pass ?test=1 for await 300ms"
              });

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x7, _x8, _x9) {
      return _ref8.apply(this, arguments);
    };
  }());
};

exports.BindGkInfoAndInjectToReqMiddleWare = BindGkInfoAndInjectToReqMiddleWare;